---
title: Crypto
slug: Web/API/Crypto
tags:
  - API
  - Code
  - Crypto
  - Encoding
  - Encryption
  - Interface
  - Privacy
  - Reference
  - Security
  - Web Crypto API
---
<p>{{APIRef("Web Crypto API")}}</p>

<p><span class="seoSummary">The <code><strong>Crypto</strong></code> interface represents basic cryptography features available in the current context. It allows access to a cryptographically strong random number generator and to cryptographic primitives.</span></p>

<p>{{AvailableInWorkers}}</p>

<p><span style="font-size: 1rem; letter-spacing: -0.00278rem;">The </span><a href="/en-US/docs/Web/API/Web_Crypto_API" style="font-size: 1rem; letter-spacing: -0.00278rem;">Web Crypto API</a><span style="font-size: 1rem; letter-spacing: -0.00278rem;"> is accessed through the {{domxref("Window.crypto")}} property, which is a </span><code style="font-size: 1rem; letter-spacing: -0.00278rem;">Crypto</code><span style="font-size: 1rem; letter-spacing: -0.00278rem;"> object.</span></p>

<h2 id="Properties">Properties</h2>

<p><em>This interface implements properties defined on {{domxref("RandomSource")}}.</em></p>

<dl>
 <dt>{{domxref("Crypto.subtle")}} {{readOnlyInline}} {{SecureContext_inline}}</dt>
 <dd>Returns a {{domxref("SubtleCrypto")}} object providing access to common cryptographic primitives, like hashing, signing, encryption, or decryption.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface implements methods defined on {{domxref("RandomSource")}}.</em></p>

<dl>
 <dt>{{domxref("Crypto.getRandomValues()")}}</dt>
 <dd>Fills the passed {{ jsxref("TypedArray") }} with cryptographically sound random values.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>You should avoid using the Web Crypto API on insecure contexts, even though the <code>Crypto</code> interface is present on insecure contexts, as is the {{domxref("Window.crypto")}} property. In addition, the <code>Crypto</code> method {{domxref("Crypto.getRandomValues", "getRandomValues()")}} is available on insecure contexts, but the {{domxref("Crypto.subtle", "subtle")}} property is not.</p>

<p>In general, you probably should just treat <code>Crypto</code> as available only on secure contexts.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Web Crypto API", "#crypto-interface", "Crypto")}}</td>
   <td>{{Spec2("Web Crypto API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Crypto")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Security">Web security</a></li>
 <li><a href="/en-US/docs/Web/Security/Secure_Contexts">Secure contexts</a></li>
 <li><a href="/en-US/docs/Web/Security/Secure_Contexts/features_restricted_to_secure_contexts">Features restricted to secure contexts</a></li>
 <li><a href="/en-US/docs/Web/Security/Transport_Layer_Security">Transport Layer Security</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Headers/Strict-Transport-Security">Strict-Transport-Security</a></li>
</ul>
